/*
 * Data.java
 * Enseignement génie logiciel - Polytech
 * Université d'Angers 
 */


package strategy;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JTextArea;


//Déclaration de la classe
public class Data 
{

	// Un objet Data est une liste de chaine de caractères 
    private List<String> Strings = new ArrayList<String>();
    public OutputType SelectedOutputType = OutputType.CONSOLE;

    //Déclaration des types de sortie disponibles
    public enum OutputType { CONSOLE, GUI };
	
    //Ajoute un mot
    public void addString(String _newString)
    { Strings.add(_newString);}
    
    // getter
    public List<String> getStrings()
    { return Strings; }
    
    // Définit l'output actuellement sélectionnée
    public void setOutputType( OutputType _type )
    {
    	SelectedOutputType = _type ;
    }

    // Déclenche l'affichage
    public void show() 
    {
		switch (SelectedOutputType) 
		{
			case CONSOLE: this.ConsoleShow();
					     break;
					
			case GUI: this.GuiShow();
					     break;
		}
	}
    // Sortie console
    private void ConsoleShow()
    {
   		for (String s : Strings) 
   		{
   			System.out.println("Chaine: " + s);
   		}
    }

    // Sortie GUI
    private void GuiShow()
    {
        //Initialisation de l'interface graphique
        JFrame frame = new JFrame("Display");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        //Zone de texte
        JTextArea textArea = new JTextArea(20, 20);
        textArea.setEditable(false); //Only for display

        //Ajout de la zone de texte
        frame.add(textArea);
        //On affiche chacune des chaines sur l'éditeur
		for(String s : Strings)
		{
            textArea.append("Chaine: " + s + "\n");
		}
        //Redimmensionne "automatiquement "la fenètre 
        frame.pack();
        
        //Rend visible la fenetre
        frame.setVisible(true);
    }
    
 
   }
